%global plugin_dir  %{_sharedstatedir}/grafana/plugins/performancecopilot-pcp-app
%global install_dir %{_datadir}/performancecopilot-pcp-app
%global gomodulesmode GO111MODULE=auto

Summary:       Performance Co-Pilot Grafana Plugin
Name:          grafana-pcp
Version:       5.2.2
Release:       1%{?dist}
License:       ASL 2.0
URL:           https://github.com/performancecopilot/grafana-pcp
Source0:       %{url}/archive/v%{version}/%{name}-%{version}.tar.gz
Source1:       grafana-pcp-vendor-%{version}-1.tar.xz
%if %{with frontend}
Source2:       grafana-pcp-webpack-%{version}-1.tar.gz
%endif
Source3:        create_bundles.sh
Source4:        build_frontend.sh
Source5:        list_bundled_nodejs_packages.py
Source6:        create_bundles_in_container.sh

Patch0001:     grafana-pcp-5.2.2-fix-CVE-2025-22870.patch

Patch3000:     0001-remove-unused-frontend-crypto.patch
Patch3001:     0002-remove-faulty-metric-tables.patch

BuildRequires: systemd-rpm-macros golang go-srpm-macros go-rpm-macros

%if %{with frontend}
BuildRequires: make nodejs yarnpkg golang-github-google-jsonnet
%endif
Requires:      grafana
%{?systemd_requires}
Suggests:      pcp redis bpftrace

	
Provides: bundled(golang(github.com/grafana/grafana-plugin-sdk-go)) = 0.250.0
Provides: bundled(golang(github.com/hashicorp/golang-lru)) = 1.0.2
Provides: bundled(golang(github.com/stretchr/testify)) = 1.9.0
Provides: bundled(npm(@babel/plugin-transform-modules-commonjs)) = 7.18.6
Provides: bundled(npm(@grafana/data)) = 9.1.6
Provides: bundled(npm(@grafana/runtime)) = 9.1.6
Provides: bundled(npm(@grafana/toolkit)) = 9.1.6
Provides: bundled(npm(@grafana/ui)) = 9.1.6
Provides: bundled(npm(@trivago/prettier-plugin-sort-imports)) = 3.4.0
Provides: bundled(npm(@types/blueimp-md5)) = 2.18.0
Provides: bundled(npm(@types/d3-selection)) = 2.0.1
Provides: bundled(npm(@types/enzyme)) = 3.10.8
Provides: bundled(npm(@types/enzyme-adapter-react-16)) = 1.0.6
Provides: bundled(npm(@types/jest)) = 26.0.24
Provides: bundled(npm(@types/lodash)) = 4.14.181
Provides: bundled(npm(@types/memoize-one)) = 5.1.2
Provides: bundled(npm(@types/react-autosuggest)) = 10.1.5
Provides: bundled(npm(@types/react-redux)) = 7.1.24
Provides: bundled(npm(@types/redux)) = 3.6.0
Provides: bundled(npm(@types/redux-persist)) = 4.3.1
Provides: bundled(npm(babel-plugin-react-remove-properties)) = 0.3.0
Provides: bundled(npm(blueimp-md5)) = 2.19.0
Provides: bundled(npm(core-js)) = 2.6.12
Provides: bundled(npm(cypress)) = 10.10.0
Provides: bundled(npm(d3-flame-graph)) = 3.1.1
Provides: bundled(npm(d3-selection)) = 1.4.2
Provides: bundled(npm(emotion)) = 10.0.27
Provides: bundled(npm(enzyme)) = 3.11.0
Provides: bundled(npm(enzyme-adapter-react-16)) = 1.15.6
Provides: bundled(npm(eslint-plugin-prettier)) = 4.2.1
Provides: bundled(npm(lodash)) = 4.17.21
Provides: bundled(npm(loglevel)) = 1.8.0
Provides: bundled(npm(loglevel-plugin-prefix)) = 0.8.4
Provides: bundled(npm(memoize-one)) = 4.1.0
Provides: bundled(npm(monaco-editor)) = 0.31.1
Provides: bundled(npm(monaco-editor-webpack-plugin)) = 7.0.1
Provides: bundled(npm(prettier-plugin-organize-imports)) = 2.3.4
Provides: bundled(npm(react-autosuggest)) = 10.1.0
Provides: bundled(npm(react-monaco-editor)) = 0.47.0
Provides: bundled(npm(react-redux)) = 7.2.9
Provides: bundled(npm(react-use)) = 17.4.0
Provides: bundled(npm(redux)) = 4.1.0
Provides: bundled(npm(redux-persist)) = 6.0.0
Provides: bundled(npm(redux-thunk)) = 2.4.1
Provides: bundled(npm(utility-types)) = 3.10.0

%description
This Grafana plugin for Performance Co-Pilot includes data sources for scalable time series from
pmseries(1) and Redis, live PCP metrics and bpftrace scripts from pmdabpftrace(1), as well as
several dashboards.

%prep
%setup -q -T -D -b 0
%setup -q -T -D -b 1
%if %{with frontend}
%setup -q -T -D -b 2
%endif

%patch -P0001 -p1
%patch -P3000 -p1
%patch -P3001 -p1

%build
%if %{with frontend}
%{SOURCE4}
%endif

%gobuild -o dist/datasources/redis/pcp_redis_datasource_$(go env GOOS)_$(go env GOARCH) ./pkg


%install
install -d -m 755 %{buildroot}/%{install_dir}
cp -a dist/* %{buildroot}/%{install_dir}

mkdir -p %{buildroot}%{_tmpfilesdir}
echo "L+ %{plugin_dir} - - - - %{install_dir}" > %{buildroot}%{_tmpfilesdir}/%{name}.conf

%postun
%systemd_postun_with_restart grafana-server.service

%posttrans
%tmpfiles_create %_tmpfilesdir/%{name}.conf

if [ -x /usr/bin/systemctl ]; then
  /usr/bin/systemctl try-restart grafana-server.service || :
fi

%check
%if %{with frontend}
yarn test
%endif

%gotest ./pkg/...


%files
%license LICENSE NOTICE
%doc README.md
%{install_dir}
%{_tmpfilesdir}/%{name}.conf
%ghost %{plugin_dir}

%changelog
* Tue May 20 2025 Feng Weiyao <wynnfeng@tencent.com> - 5.2.2-1
- upgrade to 5.2.2 and fix CVE-2023-39325 and CVE-2023-44487, CVE-2023-45288, CVE-2022-41717,CVE-2025-22870

* Mon May 19 2025 Feng Weiyao <wynnfeng@tencent.com> - 5.1.1-9
- [type] security
- [desc] fix CVE-2022-41723

* Thu May 08 2025 Feng Weiyao <wynnfeng@tencent.com> - 5.1.1-8
- [type] security
- [desc] fix CVE-2024-8986

* Thu Sep 26 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 5.1.1-7
- Rebuilt for clarifying the packages requirement in BaseOS and AppStream

* Fri Aug 16 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 5.1.1-6
- Rebuilt for loongarch release

* Fri Dec 29 2023 jackeyji <jackeyji@tencent.com> - 5.1.1-5
- Rebuilt for golang CVE-2023-39318 and CVE-2023-39319

* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 5.1.1-4
- Rebuilt for OpenCloudOS Stream 23.09

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 5.1.1-3
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 5.1.1-2
- Rebuilt for OpenCloudOS Stream 23

* Thu Mar 23 2023 Shuo Wang <abushwang@tencent.com> - 5.1.1-1
- initial build
